Imports ADODB

' Associate sequences of two paired values.
Public Class PairedValues
    Private m_Value1 As New Collection()
    Private m_Value2 As New Collection()

    ' Clear the currently loaded values.
    Public Sub ClearValues()
        m_Value1 = New Collection()
        m_Value2 = New Collection()
    End Sub

    ' Load the pairs from a Recordset's first two columns.
    Public Sub LoadFromRecordset(ByVal rs As Recordset)
        ' Clear the value pairs.
        ClearValues()

        ' Load the value pairs.
        Do While Not (rs.EOF)
            AddValuePair(rs.Fields.Item(0).Value.ToString, rs.Fields.Item(1).Value.ToString)
            rs.MoveNext()
        Loop
    End Sub

    ' Add a value pair.
    Public Sub AddValuePair(ByVal value1 As String, ByVal value2 As String)
        ' Make sure these values aren't already present.
        Try
            If Not (m_Value1.Item(value2) Is Nothing) Then
                Throw New DuplicateNameException("Value 2 '" & value2.ToString & "' is already present")
            End If
        Catch arg_exc As ArgumentException
        Catch exc As Exception
            MsgBox(exc.Message)
        End Try

        Try
            If Not (m_Value2.Item(value1) Is Nothing) Then
                Throw New DuplicateNameException("Value 1 '" & value1.ToString & "' is already present")
            End If
        Catch arg_exc As ArgumentException
        Catch exc As Exception
            MsgBox(exc.Message)
        End Try

        ' Save the values.
        m_Value1.Add(value1, value2)
        m_Value2.Add(value2, value1)
    End Sub

    ' Return the value1 for a value2.
    Public Function Value1(ByVal value2 As String) As String
        Return m_Value1.Item(value2).ToString
    End Function

    ' Return the value2 for a value1.
    Public Function Value2(ByVal value1 As String) As String
        Return m_Value2.Item(value1).ToString
    End Function
End Class
