Imports ADODB

Public Class ApplicationParameterInfo
    ' The parameter values.
    Private m_Parameters As Collections.SortedList

    ' Load the application parameters. This version uses a
    ' connectionless Recordset because the example doesn't
    ' really need a connection.
    Public Sub LoadParameters(ByVal db_name As String)
        Dim connect_string As String
        Dim query As String
        Dim rs As Recordset

        ' Get the parameters.
        connect_string = _
            "Provider=Microsoft.Jet.OLEDB.4.0;" & _
            "Data Source='" & db_name & "';" & _
            "Persist Security Info=False"
        query = _
            "SELECT ParameterName, ParameterValue " & _
            "FROM ApplicationParameters"
        rs = New Recordset()
        rs.Open(query, connect_string)

        ' Save the privilege values.
        m_Parameters = New Collections.SortedList()
        Do While Not rs.EOF
            m_Parameters.Add(rs.Fields(0).Value, rs.Fields(1).Value)
            rs.MoveNext()
        Loop

        ' Close the recordset.
        rs.Close()
        rs = Nothing
    End Sub

    ' Return the indicated parameter's value. Return the
    ' default value if the parameter is not in the list.
    Public Function ParameterValue(ByVal parameter_name As String, Optional ByVal default_value As String = "") As String
        Try
            Return m_Parameters.Item(parameter_name).ToString()
        Catch e As Exception
            Return default_value
        End Try
    End Function
End Class
